//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <registry.hpp>

#include "Global2.h"
#include "PGPKeyringSelDlgs.h"
#include "PGPsdk.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPGPKeyringSelDlg *PGPKeyringSelDlg;
//---------------------------------------------------------------------------

bool __fastcall GetPGPkeyrings(TForm *Owner, AnsiString &PublicRing, AnsiString &SecretRing)
{
   PGPKeyringSelDlg = new TPGPKeyringSelDlg(Owner, PublicRing, SecretRing);
   PGPKeyringSelDlg->ShowModal();
   bool ok = PGPKeyringSelDlg->ModalResult == mrOk;
   if (ok)
   {
      PublicRing = PGPKeyringSelDlg->PGPPublicRing->Text;
      SecretRing = PGPKeyringSelDlg->PGPSecretRing->Text;
   }
   delete PGPKeyringSelDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TPGPKeyringSelDlg::TPGPKeyringSelDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TPGPKeyringSelDlg::TPGPKeyringSelDlg(TComponent* Owner, AnsiString &PublicRing,
   AnsiString &SecretRing) : TForm(Owner)
{
   //PGPPublicRing->Text = PublicRing;
   //PGPSecretRing->Text = SecretRing;
   OpenPublicKeyDialog->InitialDir = AppDir();
   OpenSecretKeyDialog->InitialDir = AppDir();
}
//---------------------------------------------------------------------------

void __fastcall TPGPKeyringSelDlg::Button1Click(TObject *Sender)
{
  if (PGPPublicRing->Text.IsEmpty())
  {
     OpenPublicKeyDialog->InitialDir = OpenSecretKeyDialog->InitialDir;
  }

  if (OpenPublicKeyDialog->Execute())
  {
     PGPPublicRing->Text = OpenPublicKeyDialog->FileName;
  }
}
//---------------------------------------------------------------------------

void __fastcall TPGPKeyringSelDlg::Button2Click(TObject *Sender)
{
  if (PGPSecretRing->Text.IsEmpty())
  {
     OpenSecretKeyDialog->InitialDir = OpenPublicKeyDialog->InitialDir;
  }

  if (OpenSecretKeyDialog->Execute())
  {
     PGPSecretRing->Text = OpenSecretKeyDialog->FileName;
  }
}
//---------------------------------------------------------------------------

void __fastcall TPGPKeyringSelDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      bool pubok = FileExists(PGPPublicRing->Text);
      bool secok = FileExists(PGPSecretRing->Text);
      if (!pubok && !secok)
      {
         MsgBox(this, "Sorry, the keyrings you specified don't exist!", MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      if (!pubok)
      {
         MsgBox(this, "Sorry, the public keyring you specified doesn't exist!", MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      if (!secok)
      {
         MsgBox(this, "Sorry, the secret keyring you specified doesn't exist!", MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      if (ExtractFilePath(PGPPublicRing->Text) != ExtractFilePath(PGPSecretRing->Text))
      {
         MsgBox(this,
            "The keyrings you have specified are not in the same directory.\n"
            "Place them both in the same directory and select again.",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      TRegistry *reg = new TRegistry();
      try {
         if (reg->OpenKey(QuickSilverRegKey,true))
         {
            reg->WriteString(PGPPublicRegKey, PGPPublicRing->Text);
            reg->WriteString(PGPSecretRegKey, PGPSecretRing->Text);
            reg->CloseKey();
         }
      }
      catch (...) {
         MsgBox(this,
            AnsiString("Unable to write to windows registry!\n\n")+
            AnsiString("Entries NOT saved!"),
           "Registry Error",MB_OK);
      }
      delete reg;
   }
}
//---------------------------------------------------------------------------
